﻿# -*- coding=utf-8 -*-

# une exception propriétaire
class MyError(Exception):
    pass

# trois méthodes
def f1(x):
    # on ne gère pas les exceptions - elles remontent automatiquement
    return f2(x)

def f2(y):
    # on ne gère pas les exceptions - elles remontent automatiquement
    return f3(y)

def f3(z):
    if (z % 2) == 0:
        # si z est pair, on lance une exception
        raise MyError("exception dans f3")
    else:
        return 2*z

#---------- main

# les exceptions remontent la chaîne des méthodes appelées
# jusqu'à ce qu'une méthode l'intercepte. Ici ce sera main
try:
    print f1(4)
except MyError as infos:
    print "type :%s, arguments : %s" % (type(infos),infos)

# une méthode peut enrichir les exceptions qu'elle remonte
def f4(x):
    try:
        return f5(x)
    except MyError as infos:
        # on enrichit l'exception puis on la relance
        raise MyError(infos,"exception dans f4")

def f5(y):
    try:
        return f6(y)
    except MyError as infos:
        # on enrichit l'exception puis on la relance
        raise MyError(infos, "exception dans f5")

def f6(z):
    if (z % 2) == 0:
        # on lance une exception
        raise MyError("exception dans f6")
    else:
        return 2*z

#---------- main
try:
    print f4(4)
except MyError as infos:
    print "type :%s, arguments : %s" % (type(infos),infos)
