# -*- coding=utf-8 -*-

# import du module des classes Impots
from impots import *
import re

# --------------------------------------------------------------------------
def copyToMysql(limites,coeffR,coeffN,HOTE,USER,PWD,BASE,TABLE):
    # copie les 3 tableaux numériques limites, coeffR, coeffN
    # dans la table TABLE de la base mysql BASE
    # la base mysql est sur la machine HOTE
    # l'utilisateur est identifié par USER et PWD

    # on met les requêtes SQL dans une liste
    # suppression de la table
    requetes=["drop table %s" % (TABLE)]
    # création de la table
    requete="create table %s (limites decimal(10,2), coeffR decimal(6,2), coeffN decimal(10,2))" % (TABLE)
    requetes.append(requete)
    # remplissage
    for i in range(len(limites)):
        # requête d'insertion
        requetes.append("insert into %s (limites,coeffR,coeffN) values (%s,%s,%s)" % (TABLE,limites[i],coeffR[i],coeffN[i]))
    # on exécute les ordres SQL
    return executerCommandes(HOTE,USER,PWD,BASE,requetes,False,False)
    

def executerCommandes(HOTE,ID,PWD,BASE,requetes,suivi=False,arret=True):
    # utilise la connexion (HOTE,ID,PWD,BASE)
    # exécute sur cette connexion les commandes SQL contenues dans la liste requetes
    # si suivi=True alors chaque exécution d'un ordre SQL fait l'objet d'un affichage indiquant sa réussite ou son échec
    # si arret=False, la fonction s'arrête sur la 1ère erreur rencontrée sinon elle exécute ttes les commandes sql
    # la fonction rend une liste (nb d'erreurs, erreur1, erreur2, ...)

    # connexion
    try:
        connexion=MySQLdb.connect(host=HOTE,user=ID,passwd=PWD,db=BASE)
    except MySQLdb.OperationalError,erreur:
        return [1,"Erreur lors de la connexion a MySql sous l'identite (%s,%s,%s,%s) : %s" % (HOTE, ID, PWD, BASE, erreur)]
      
    # on demande un curseur
    curseur=connexion.cursor()
    # exécution des requêtes SQL contenues dans la liste requetes
    # on les exécute - au départ pas d'erreurs
    erreurs=[0]
    for i in range(len(requetes)):
        # on met la requête dans une variable locale
        requete=requetes[i]
        # a-t-on une requête vide ?
        if re.match(r"^\s*$",requete):
            continue
        # exécution de la requête i
        erreur=""
        try:
            curseur.execute(requete)
        except Exception, erreur:
            pass
        # y-a-t-il eu une erreur ?
        if erreur:
            # une erreur de plus
            erreurs[0]+=1
            # msg d'erreur
            msg="%s : Erreur (%s)" % (requete[0:len(requete)-1],erreur)
            erreurs.append(msg)
            # suivi écran ou non ?
            if suivi:
                print msg
            # on s'arrête ?
            if arret:
                return erreurs
        else:
            if suivi: 
                # on affiche la requête sans sa marque de fin de ligne
                print "%s : Execution reussie" % (cutNewLineChar(requete))
                # infos sur le résultat de la requête exécutée
                afficherInfos(curseur)
    # fermeture connexion
    try:
        connexion.commit()
        connexion.close()
    except MySQLdb.OperationalError,erreur:
        # une erreur de plus
        erreurs[0]+=1
        # msg d'erreur
        msg="%s : Erreur (%s)" % (requete,erreur)
        erreurs.append(msg)

    # retour
    return erreurs


# ------------------------------------------------ main
# l'identité de l'utilisateur
USER="root"
PWD=""
# la machine hôte du sgbd
HOTE="localhost"
# identité de la base
BASE="dbimpots"
# identité de la table des données
TABLE="impots"
# le fichier des données
IMPOTS="impots.txt"

# instanciation couche [dao]
try:
    dao=ImpotsFile(IMPOTS)
except (IOError, ImpotsError) as infos:
    print ("Une erreur s'est produite : {0}".format(infos))
    sys.exit()

# on transfère les données récupérées dans une table mysql
erreurs=copyToMysql(dao.limites,dao.coeffR,dao.coeffN,HOTE,USER,PWD,BASE,TABLE)
if erreurs[0]:
    for i in range(1,len(erreurs)):
        print erreurs[i]
else:
    print "Transfert opere"
# fin
sys.exit()


