﻿# -*- coding=utf-8 -*-

# serveur tcp générique sur Windows

# chargement des fichiers d'en-tête
import re,sys,SocketServer,threading

# serveur tcp multi-threadé
class ThreadedTCPRequestHandler(SocketServer.StreamRequestHandler):

  def handle(self):
    # thread courant
    cur_thread = threading.currentThread()
    # données du client
    self.data="on"
    # arrêt sur chaine vide
    while self.data:
      # les lignes de texte du client sont lues avec la méthode readline
      self.data =self.rfile.readline().strip()
      # suivi console
      print "client %s : %s (%s)" % (self.client_address[0],self.data,cur_thread.getName())
      # envoi réponse au client
      response = "%s: %s" % (cur_thread.getName(), self.data.upper())
      # self.wfile est le flux d'écriture vers client
      self.wfile.write(response)                    

class ThreadedTCPServer(SocketServer.ThreadingMixIn, SocketServer.TCPServer):
    pass

# ------------------------------------------------------ main        
# syntaxe d'appel : argv[0] port
# le serveur est lancé sur le port nommé

# Données
syntaxe="syntaxe : %s port" % (sys.argv[0])

#------------------------------------- on vérifie l'appel
# il doit y avoir un argument et un seul
nbArguments=len(sys.argv)
if nbArguments!=2:
	print syntaxe
	sys.exit(1)

# le port doit être numérique
port=sys.argv[1]
modele=r"^\s*\d+\s*$"
if not re.match(modele,port):
	print "Le port %s n'est pas un nombre entier positif\n" % (port)
	sys.exit(2)

# lancement du serveur - sert chaque client sur un thread
host="localhost"
server = ThreadedTCPServer((host,int(port)), ThreadedTCPRequestHandler)

# le serveur est lancé dans un thread
# chaque client sera servi dans un thread supplémentaire
server_thread = threading.Thread(target=server.serve_forever)
# lance le serveur - boucle infinie d'attente des clients
server_thread.start()
# suivi
print "Serveur d'echo a l'ecoute sur le port % s" % (port)
