﻿# -*- coding=utf-8 -*-

# serveur tcp générique

# chargement des fichiers d'en-tête
import re,sys,SocketServer,threading

# serveur tcp générique
class MyTCPHandler(SocketServer.StreamRequestHandler):
    def handle(self):
        # on affiche le client
        print "client %s" % (self.client_address[0])
        # on crée un thread de lecture des commandes du client
        thread_lecture = threading.Thread(target=self.lecture)
        thread_lecture.start()
        # arrêt sur cmde 'bye'
        # lecture cmde tapée au clavier
        cmde=raw_input("--> ")
        while cmde!="bye":
            # envoi cmde au client. self.wfile est le flux d'écriture vers le client
            self.wfile.write("%s\n" % (cmde))
            # lecture cmde suivante
            cmde=raw_input("--> ")

    def lecture(self):
        # on affiche toutes les lignes envoyées par le client jusqu'à recevoir la commande bye
        ligne=""
        while ligne!="bye":
            # les lignes de texte du client sont lues avec la méthode readline
            ligne = self.rfile.readline().strip()
            # suivi console
            print "<--- %s : %s" % (self.client_address[0], ligne)
    
# ------------------------------------------------------ main        
# syntaxe d'appel : argv[0] port
# le serveur est lancé sur le port nommé

# Données
syntaxe="syntaxe : %s port" % (sys.argv[0])

#------------------------------------- on vérifie l'appel
# il doit y avoir un argument et un seul
nbArguments=len(sys.argv)
if nbArguments!=2:
	print syntaxe
	sys.exit(1)

# le port doit être numérique
port=sys.argv[1]
modele=r"^\s*\d+\s*$"
if not re.match(modele,port):
	print "Le port %s n'est pas un nombre entier positif\n" % (port)
	sys.exit(2)

# lancement du serveur
host="localhost"
server = SocketServer.TCPServer((host, int(port)), MyTCPHandler)
print "Service tcp generique lance sur le port %s. Arret par Ctrl-C" % (port)
server.serve_forever()
