﻿# import des modules
import sys
sys.path.append("D:\Programs\ActivePython\site-packages")
import MySQLdb
# autres modules
import re

def cutNewLineChar(ligne):
    # on supprime la marque de fin de ligne de [ligne] si elle existe
    l=len(ligne)
    while(ligne[l-1]=="\n" or ligne[l-1]=="\r"):
        l-=1
    return(ligne[0:l])

# ---------------------------------------------------------------------------------
def afficherInfos(curseur):
    # affiche le résultat d'une requête sql
    # s'agissait-il d'un select ?
    if curseur.description:
        # il y a une description - donc c'est un select
        # description[i] est la description de la colonne n° i du select
        # description[i][0] est le nom de la colonne n° i du select
        # on affiche les noms des champs
        titre=""
        for i in range(len(curseur.description)):
            titre+=curseur.description[i][0]+","
        # on affiche la liste des champs sans la virgule de fin
        print titre[0:len(titre)-1]
        # ligne séparatrice
        print "-"*(len(titre)-1)
        # ligne courante du select
        ligne=curseur.fetchone()
        while ligne:
            print ligne
            # ligne suivante du select
            ligne=curseur.fetchone()
    else:
        # il n'y a pas de champs - ce n'était pas un select
        print "%s lignes(s) a (ont) ete modifiee(s)" % (curseur.rowcount)


# ---------------------------------------------------------------------------------
def executerCommandes(HOTE,ID,PWD,BASE,SQL,suivi=False,arret=True):
    # utilise la connexion (HOTE,ID,PWD,BASE)
    # exécute sur cette connexion les commandes SQL contenues dans le fichier texte SQL
    # ce fichier est un fichier de commandes SQL à exécuter à raison d'une par ligne
    # si suivi=1 alors chaque exécution d'un ordre SQL fait l'objet d'un affichage indiquant sa réussite ou son échec
    # si arret=1, la fonction s'arrête sur la 1ère erreur rencontrée sinon elle exécute ttes les commandes sql
    # la fonction rend un tableau (nb d'erreurs, erreur1, erreur2, ...)

    # on vérifie la présence du fichier SQL
    data=None
    try:
        data=open(SQL,"r")
    except:
        return [1,"Le fichier %s n'existe pas" % (SQL)]

    # connexion
    try:
        connexion=MySQLdb.connect(host=HOTE,user=ID,passwd=PWD,db=BASE)
    except MySQLdb.OperationalError,erreur:
        return [1,"Erreur lors de la connexion a MySql sous l'identite (%s,%s,%s,%s) : %s" % (HOTE, ID, PWD, BASE, erreur)]
    
    # on demande un curseur
    curseur=connexion.cursor()
    # exécution des requêtes SQL contenues dans le fichier SQL
    # on les met dans un tableau
    requetes=data.readlines()
    # on les exécute une à une - au départ pas d'erreurs
    erreurs=[0]
    for i in range(len(requetes)):
        # on mémorise la requête courante
        requete=requetes[i]
        # a-t-on une requête vide ? Si oui, on passe à la requête suivante
        if re.match(r"^\s*$",requete):
            continue
        # exécution de la requête i
        erreur=""
        try:
            curseur.execute(requete)
        except Exception, erreur:
            pass
        #y-a-t-il eu une erreur ?
        if erreur:
            # une erreur de plus
            erreurs[0]+=1
            # msg d'erreur
            msg="%s : Erreur (%s)" % (requete,erreur)
            erreurs.append(msg)
            # suivi écran ou non ?
            if suivi:
                print msg
            # on s'arrête ?
            if arret:
                return erreurs
        else:
            if suivi: 
                print "%s : Execution reussie" % (requete)
                # infos sur le résultat de la requête exécutée
                afficherInfos(curseur)

    # fermeture connexion et libération des ressources
    curseur.close()
    connexion.commit()
    # on se deconnecte
    try:
        connexion.close()
    except MySQLdb.OperationalError,erreur:
        # une erreur de plus
        erreurs[0]+=1
        # msg d'erreur
        msg="%s : Erreur (%s)" % (requete,erreur)
        erreurs.append(msg)

    # retour
    return erreurs


# ---------------------------------------------- main
# connexion à la base MySql
# l'identité de l'utilisateur
ID="admpersonnes"
PWD="nobody"
# la machine hôte du sgbd
HOTE="localhost"
# identité de la base
BASE="dbpersonnes"
# identité du fichier texte des commandes SQL à exécuter
TEXTE="sql2.txt"


# création et remplissage de la table
erreurs=executerCommandes(HOTE,ID,PWD,BASE,TEXTE,True,False)
#affichage nombre d'erreurs
print "il y a eu %s erreur(s)" % (erreurs[0])
for i in range(1,len(erreurs)):
    print erreurs[i]
