﻿#!D:\Programs\ActivePython\Python2.7.2\python.exe

# -*- coding=Utf-8 -*-
# import du module des classes Impots*
from impots import *
import cgi,cgitb,re

# on autorise l'affichage d'informations de débogage
cgitb.enable()

# ------------------------------------------------ 
# le service web des impôts
# ------------------------------------------------ 

# les données nécessaires au calcul de l'impôt ont été placées dans la table mysqL TABLE
# appartenant à la base BASE. La table a la structure suivante
# limites decimal(10,2), coeffR decimal(6,2), coeffN decimal(10,2)
# les paramètres des personnes imposables (statut marital, nombre d'enfants, salaire annuel)
# sont envoyés par le client sous la forme params=statut marital, nombre d'enfants, salaire annuel
# les résultats (statut marital, nombre d'enfants, salaire annuel, impôt à payer) sont renvoyés au client
# sous la forme <impot>valeur</impot>
# ou sous la forme <erreur>msg</erreur>, si les paramètres sont invalides

# le serveur renvoie au client du texte non formaté
print "Content-Type: text/plain\n"
# début de la réponse
print "<reponse>"

# définition des constantes
USER="root"
PWD=""
HOTE="localhost"
BASE="dbimpots"
TABLE="impots"

# instanciation couche [metier]
try:
    metier=ImpotsMetier(ImpotsMySQL(HOTE,USER,PWD,BASE,TABLE))
except (IOError, ImpotsError) as infos:
    print ("Une erreur s'est produite : {0}".format(infos))
    sys.exit()

# on récupère la ligne envoyée par le client au serveur
params=cgi.FieldStorage().getlist('params')
# si pas de paramètres alors erreur
if not params:
    print "<erreur>Le parametre [params] est absent<erreur></reponse>"
    sys.exit()

# on exploite le paramètre params  
#print "parametres recus --> %s\n" %(params)
items=params[0].strip().lower().split(',')
# il ne doit y avoir que 3 champs
if len(items)!=3:
    print "<erreur>[%s] : nombre de parametres invalide</erreur></reponse>" % (params[0])
    sys.exit()
# le premier paramètre (statut marital) doit être oui/non
marie=items[0].strip()
if marie!="oui" and marie != "non":
    print "<erreur>[%s] : 1er parametre invalide</erreur></reponse>\n"% (params[0])
    sys.exit()
# le second paramètre (nbre d'enfants) doit être un nombre entier
match=re.match(r"^\s*(\d+)\s*$",items[1])
if not match:
    print "<erreur>[%s] : 2ieme parametre invalide</erreur></reponse>\n"% (params[0])
    sys.exit()
enfants=int(match.groups()[0])
# le troisième paramètre (salaire) doit être un nombre entier
match=re.match(r"^\s*(\d+)\s*$",items[2])
if not match:
    print "<erreur>[%s] : 2ieme parametre invalide</erreur></reponse>\n"% (params[0])
    sys.exit()
salaire=int(match.groups()[0])
# on calcule l'impôt
impot=metier.calculer(marie,enfants,salaire)
# on renvoie le résultat
print "<impot>%s</impot></reponse>\n" % (impot)
# fin
